/* 
   ***********************
   INPUTS Microcontrolador
   ***********************
 */

// Pins control rotatori
#define pitjar 0                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        
#define girA 11
#define girB 2

// Pins control MUX16d
#define control0 21
#define control1 20
#define control2 19
#define control3 18
#define digitalData 28  // a4
#define analogData 27   // a3

#define activarRotatori2 23

/* 
   *********************
   MUX16d INPUTS (xip 1)
   *********************
 */

// Finals de carrera eix X
#define FCx1 0 // FINAL ESQUERRE. LOW = activat
#define FCx2 3 // FINAL DRET. LOW = activat
#define FCa 6
#define FCz 9
#define FCy 12

// Botons pulsadors
#define botoLeft 15
#define botoRight 14

/* 
   *********************
   MUX16a INPUTS (xip 2)
   *********************
 */

#define envelope 0

/* 
   ************************
   OUTPUTS Microcontrolador
   ************************
 */

// Pins motor eix Z (mola)
#define eixZstep 13
#define eixZdirection 12

// Pins motor eix X (capçal)
#define eixXstep 14
#define eixXdirection 15

// Pins motor eix A (divisor)
#define eixAstep 7
#define eixAdirection 1

// Pins motor eix Y (quart eix nou)
#define eixYstep 8
#define eixYdirection 9

// Pins control LCD
#define db3 3
#define db4 4
#define db6 6
#define db10 10
#define RW 24    // a0
#define RS 25	 // a1
#define E1 26	 // a2
#define E2 22

// Pins control OUT16
#define dataPin 29    // a5
#define latchPin 30   // a6
#define clockPin 31   // a7

/* 
   *************
   OUT16 OUTPUTS
   *************
 */

#define onGeneral 0
#define molaGirEsquerra 1
#define molaGirDreta 2
#define mola2On 3
#define aiguaMotor 4
#define llumBotoRight 14
#define llumBotoLeft 15
#define platMagnetic 5

/*
   *********
   CONSTANTS
   *********
 */

#define N_PROGS1 8
#define N_PROGS2 12
#define N_PANTALLES_MENUINICIAL 4
#define PROPS_VAR 5
#define N_INDEX_VARS 76 // 14 comu, 7 classic, 9 quart eix
#define N_VARS_PROGRAMA 30
#define N_VARS_GENERALS 46
#define INIT_POS_VARSGENERALS_EEPROM N_VARS_PROGRAMA * N_PROGS2
#define MAX_MILLIS 429496729
#define CODI_FINAL 25007 // 5 xifres = INICI_DIGIT_CODIFINAL 4. 6 xifres = 3. Etc..
#define CODI_PROVISIONAL 935417901
#define CODI_PROVISIONAL2 604673048
#define VEL_PLAT 4000
#define VEL_EIXY 4000
#define VEL_EIXY_CONSTANT_AUTO 30
#define STEPS_RECTIFICAT_TROBARFC 180
#define N_MEDICIONS 10
#define INICI_DIGIT_CODIFINAL 4
#define STEPS_EIXA 55
#define RECORREGUT_A 50040L // 90 graus: 810 cops 56 steps, + 90 cops 52 steps
#define LATCH_BACKOFF_Y 4000
#define LATCH_BACKOFF_Z 4000
#define LATCH_BACKOFF_A 4000
#define STEPSEIXYMANUAL_H 100
#define SEPARACIO_MOLA 5000

/*
   ******************************
   IDX VARIABLES PROGRAMA COMUNES
   ******************************
 */
 
#define idxDesbast 0 * PROPS_VAR
#define idxDesbastDec_low 1 * PROPS_VAR
#define idxDesbastDec_high 2 * PROPS_VAR
#define idxDesbastDivDec_low 3 * PROPS_VAR
#define idxDesbastDivDec_high 4 * PROPS_VAR
#define idxDesbastVel 5 * PROPS_VAR
#define idxAcabat 6 * PROPS_VAR
#define idxAcabatDec_low 7 * PROPS_VAR
#define idxAcabatDec_high 8 * PROPS_VAR
#define idxAcabatDivDec 9 * PROPS_VAR
#define idxAcabatVel 10 * PROPS_VAR
#define idxLapejat 11 * PROPS_VAR
#define idxLapejatVel 12 * PROPS_VAR
#define idxProduccio 13 * PROPS_VAR

/*
   ***********************************
   MINS/MAX VARIABLES PROGRAMA COMUNES
   ***********************************
 */
 
#define DESBAST_L 0
#define DESBAST_H 20
#define DESBAST_DEC_LOW_L 0         // Suma de LOW L_H = 1 = valor minim de DesbastDecimal (int)
#define DESBAST_DEC_LOW_H 0
#define DESBAST_DEC_HIGH_L 231      // Suma de HIGH L_H = 999 = valor minim de DesbastDecimal (int)
#define DESBAST_DEC_HIGH_H 3
#define DESBASTDIV_DEC_LOW_L 1      // Suma de LOW L_H = 1 = valor minim de DesbastDecimal (int)
#define DESBASTDIV_DEC_LOW_H 0
#define DESBASTDIV_DEC_HIGH_L 244   // Suma de HIGH L_H = 500 = valor minim de DesbastDecimal (int)
#define DESBASTDIV_DEC_HIGH_H 1
#define DESBAST_VEL_L 1
#define DESBAST_VEL_H 120
#define ACABAT_L 0
#define ACABAT_H 0
#define ACABAT_DEC_LOW_L 0          // Suma de LOW L_H = 1 = valor minim de DesbastDecimal (int)
#define ACABAT_DEC_LOW_H 0
#define ACABAT_DEC_HIGH_L 231       // Suma de HIGH L_H = 999 = valor minim de DesbastDecimal (int)
#define ACABAT_DEC_HIGH_H 3
#define ACABATDIV_DEC_L 1      
#define ACABATDIV_DEC_H 250
#define ACABAT_VEL_L 1
#define ACABAT_VEL_H 120
#define LAPEJAT_L 0
#define LAPEJAT_H 20
#define LAPEJAT_VEL_L 1
#define LAPEJAT_VEL_H 120
#define PRODUCCIO_L 0
#define PRODUCCIO_H 1

/*
   ******************************
   IDX VARIABLES PROGRAMA CLASSIC
   ******************************
 */
 
#define idxAngle1 14 * PROPS_VAR
#define idxAngle1Dec 15 * PROPS_VAR
#define idxAngle2 16 * PROPS_VAR
#define idxAngle2Dec 17 * PROPS_VAR
#define idxGirMola 18 * PROPS_VAR
#define idxBaixada 19 * PROPS_VAR
#define idxMedicio 20 * PROPS_VAR

/*
   ***********************************
   MINS/MAX VARIABLES PROGRAMA CLASSIC
   ***********************************
 */
 
#define ANGLE1_L 0
#define ANGLE1_H 90
#define ANGLE1_DEC_L 0
#define ANGLE1_DEC_H 9
#define ANGLE2_L 0
#define ANGLE2_H 90
#define ANGLE2_DEC_L 0
#define ANGLE2_DEC_H 9
#define GIRMOLA_L 0
#define GIRMOLA_H 1
#define BAIXADA_L 0
#define BAIXADA_H 2
#define MEDICIO_L 0
#define MEDICIO_H 1
 
/*
   ********************************
   IDX VARIABLES PROGRAMA QUART EIX
   ********************************
 */
 
#define idxNdents_low 21 * PROPS_VAR
#define idxNdents_high 22 * PROPS_VAR
#define idxPasDent 23 * PROPS_VAR
#define idxPasDentDec 24 * PROPS_VAR
#define idxAngle3 25 * PROPS_VAR
#define idxAngle3Dec 26 * PROPS_VAR
#define idxMolaRpm_low 27 * PROPS_VAR
#define idxMolaRpm_high 28 * PROPS_VAR
#define idxRecAfilat 29 * PROPS_VAR
 
 /*
   *************************************
   MINS/MAX VARIABLES PROGRAMA QUART EIX
   *************************************
 */
 
#define NDENTS_LOW_L 1
#define NDENTS_LOW_H 0
#define NDENTS_HIGH_L 184 // 3000 = 188low + 11high (en 2 bytes)
#define NDENTS_HIGH_H 11
#define PASDENT_L 0
#define PASDENT_H 40
#define PASDENT_DEC_L 0
#define PASDENT_DEC_H 9
#define ANGLE3_L 0
#define ANGLE3_H 90
#define ANGLE3_DEC_L 0
#define ANGLE3_DEC_H 9
#define MOLARPM_LOW_L 208 // 2000 = 208low + 7high
#define MOLARPM_LOW_H 7
#define MOLARPM_HIGH_L 240 // 22000 = 240low + 85high
#define MOLARPM_HIGH_H 85
#define RECAFILAT_L 1
#define RECAFILAT_H 250

/*
   ******************
   IDX VARIABLES TEXT
   ******************
 */
 
#define idxGirMolaPrint 1
#define idxProduccioPrint 3
#define idxMedicioPrint 3
#define idxBaixadaPrint 5
#define idxActivarMedicioPrint 3
#define idxActivarMagnetismePrint 3
#define idxActivarQuartEixPrint 3
#define idxRefrigeracioPrint 8

/*
   *************************
   IDX VARIABLES MENU SECRET
   *************************
 */

#define idxActivarMedicio 30 * PROPS_VAR
#define idxIncrementVel_low  31 * PROPS_VAR
#define idxIncrementVel_high 32 * PROPS_VAR
#define idxAcc_low 33 * PROPS_VAR
#define idxAcc_high 34 * PROPS_VAR
#define idxDacc_low 35 * PROPS_VAR
#define idxDacc_high 36 * PROPS_VAR
#define idxActivarMagnetisme 37 * PROPS_VAR
#define idxRecorregutZ_low 38 * PROPS_VAR
#define idxRecorregutZ_high 39 * PROPS_VAR
#define idxRecorregutZ_high2 40 * PROPS_VAR
#define idxActivarQuartEix 41 * PROPS_VAR
#define idxRecorregutY_low 42 * PROPS_VAR
#define idxRecorregutY_high 43 * PROPS_VAR
#define idxRecorregutY_high2 44 * PROPS_VAR
#define idxVelocitatZ_low 45 * PROPS_VAR
#define idxVelocitatZ_high 46 * PROPS_VAR

 /*
   ******************************
   MINS/MAX VARIABLES MENU SECRET
   ******************************
 */

#define ACTIVAR_MEDICIO_L 0
#define ACTIVAR_MEDICIO_H 1
#define INCREMENT_VEL_LOW_L 0
#define INCREMENT_VEL_LOW_H 0
#define INCREMENT_VEL_HIGH_L 231 // Formen el 999
#define INCREMENT_VEL_HIGH_H 3
#define ACC_LOW_L 100
#define ACC_LOW_H 0
#define ACC_HIGH_L 160 // Formen el 4000
#define ACC_HIGH_H 15
#define DACC_LOW_L 50
#define DACC_LOW_H 0
#define DACC_HIGH_L 232 // Formen el 1000
#define DACC_HIGH_H 3
#define ACTIVAR_MAGNETISME_L 0
#define ACTIVAR_MAGNETISME_H 1
#define RECORREGUTZ_LOW_L 100
#define RECORREGUTZ_LOW_H 0
#define RECORREGUTZ_HIGH_L 66 // Limit de byte intermig no ens importa
#define RECORREGUTZ_HIGH_H 0
#define RECORREGUTZ_HIGH2_L 15 // Formen el 1.000.000 entre tots tres bytes
#define RECORREGUTZ_HIGH2_H 0
#define QUART_EIX_L 0
#define QUART_EIX_H 1
#define RECORREGUTY_LOW_L 100
#define RECORREGUTY_LOW_H 0
#define RECORREGUTY_HIGH_L 66 // Limit de byte intermig no ens importa
#define RECORREGUTY_HIGH_H 0
#define RECORREGUTY_HIGH2_L 15 // Formen el 1.000.000 entre tots tres bytes
#define RECORREGUTY_HIGH2_H 0
#define VELOCITATZ_LOW_L 100
#define VELOCITATZ_LOW_H 0
#define VELOCITATZ_HIGH_L 136
#define VELOCITATZ_HIGH_H 19

/*
   ***************************
   IDX VARIABLES VALORS PROCES
   ***************************
 */
 
#define idxVelManualX 47 * PROPS_VAR
#define idxStepsManualZ 48 * PROPS_VAR
#define idxStepsManualY 49 * PROPS_VAR
#define idxOffsetA 50 * PROPS_VAR
#define idxOffsetAdec 51 * PROPS_VAR
#define idxSensibilitat_low 52 * PROPS_VAR
#define idxSensibilitat_high 53 * PROPS_VAR
#define idxCompensacio_low 54 * PROPS_VAR
#define idxCompensacio_high 55 * PROPS_VAR
#define idxRefrigeracio 56 * PROPS_VAR

 /*
   ********************************
   MINS/MAX VARIABLES VALORS PROCES
   ********************************
 */
 
#define VELMANUALX_L 1
#define VELMANUALX_H 120
#define STEPSMANUALZ_L 1
#define STEPSMANUALZ_H 250
#define STEPSMANUALY_L 1
#define STEPSMANUALY_H 100
#define OFFSETA_L 246 // Equival a -10
#define OFFSETA_H 12
#define OFFSETA_DEC_L 0
#define OFFSETA_DEC_H 9
#define SENSIBILITAT_LOW_L 10
#define SENSIBILITAT_LOW_H 0
#define SENSIBILITAT_HIGH_L 244
#define SENSIBILITAT_HIGH_H 1
#define COMPENSACIO_LOW_L 0
#define COMPENSACIO_LOW_H 0
#define COMPENSACIO_HIGH_L 244
#define COMPENSACIO_HIGH_H 1
#define REFRIGERACIO_L 0
#define REFRIGERACIO_H 1
 
/*
   ********************
   IDX VARIABLES ALTRES
   ********************
 */

#define idxHoresTotals_low 57 * PROPS_VAR
#define idxHoresTotals_high 58 * PROPS_VAR
#define idxHoresCicle_low 59 * PROPS_VAR
#define idxHoresCicle_high 60 * PROPS_VAR
#define idxHoresRecanvis_low 61 * PROPS_VAR
#define idxHoresRecanvis_high 62 * PROPS_VAR
#define idxMinutsCicleRestants 63 * PROPS_VAR
#define idxCodiFinalIntroduit 64 * PROPS_VAR
#define idxCodiProv1Introduit 65 * PROPS_VAR
#define idxCodiProv2Introduit 66 * PROPS_VAR
#define idxAny 67 * PROPS_VAR
#define idxMes 68 * PROPS_VAR
#define idxDia 69 * PROPS_VAR
#define idxHora 70 * PROPS_VAR
#define idxMinut 71 * PROPS_VAR
#define idxSegon 72 * PROPS_VAR
#define idxMagnetitzat 73 * PROPS_VAR

 /*
   *************************
   MINS/MAX VARIABLES ALTRES
   *************************
 */
 
#define HORESTOTALS_LOW_L 0
#define HORESTOTALS_LOW_H 0
#define HORESTOTALS_HIGH_L 255
#define HORESTOTALS_HIGH_H 255
#define HORESCICLE_LOW_L 0 
#define HORESCICLE_LOW_H 0
#define HORESCICLE_HIGH_L 244 // 500 hores
#define HORESCICLE_HIGH_H 1
#define HORESRECANVIS_LOW_L 0
#define HORESRECANVIS_LOW_H 0
#define HORESRECANVIS_HIGH_L 232 // 1000 hores
#define HORESRECANVIS_HIGH_H 3
#define MINUTSCICLE_RESTANTS_L 0
#define MINUTSCICLE_RESTANTS_H 59
#define CODIFINAL_INTRO_L 0
#define CODIFINAL_INTRO_H 1
#define CODIPROV1_INTRO_L 0
#define CODIPROV1_INTRO_H 1
#define CODIPROV2_INTRO_L 0
#define CODIPROV2_INTRO_H 1
#define BYTE_ESTANDARD_L 0
#define BYTE_ESTANDARD_H 255
#define MAGNETITZAT_L 0
#define MAGNETITZAT_H 1

/*
   *********************************
   IDX VARIABLES ALTRES sense EEPROM
   *********************************
 */
 
#define idxPrograma 74 * PROPS_VAR
#define idxDigitCodiActual 75 * PROPS_VAR

 /*
   **************************************
   MINS/MAX VARIABLES ALTRES sense EEPROM
   **************************************
 */

#define PROGRAMA_L 0
#define PROGRAMA_H 11
#define DIGIT_CODI_ACTUAL_L 0
#define DIGIT_CODI_ACTUAL_H 9
