
#if(ARDUINO >= 100)
#include <Arduino.h>
#else
#include <WProgram.h>
#endif

#include <inttypes.h>

boolean pitjat = false;
boolean edit = false;
boolean leftPitjat = false;
boolean rightPitjat = false;
boolean parpadeigLlum = false;
boolean llumOn = false;
boolean finalDretDetectat = false;
boolean finalEsquerreDetectat = false;
boolean firstIn = false;
boolean carroMoventse = false;
boolean comprovarMovimentCarroDretManual = false;
boolean comprovarMovimentCarroEsquerreManual = false;
boolean comprovarMovimentCarroDretAuto = false;
boolean comprovarMovimentCarroEsquerreAuto = false;
boolean pausat = false;
boolean pausaEnEspera = false;
boolean aturaEnEspera = false;
boolean bloqueigBotons = false;
boolean cursorAlInici = true;
boolean tempsCicleActivat = false;
boolean desplasantCarroPrevi = false;
boolean platMagneticOn = false;
boolean comprovarDesactivarPlat = false;
boolean bloqueigMaquina = false;
boolean rectificantTrobarFC = false;
boolean mesurarSoroll = false;
boolean divisorCanviat = false;
boolean errors = false;
boolean avisos = false;
boolean firstRight = false;
boolean firstLeft = false;
boolean comprovarMenuSecret = false;
boolean confirmarAutoOsalir = false;
boolean printarSalir = false;
boolean previReferenciar = false;
boolean referenciatOk = true;
boolean sumantGrausDivisor;
boolean iniciantEsmolatAngle2 = false;
boolean esmolantAngle2 = false;
boolean existeixAngle2 = false;
boolean existeixAngle1 = false;
boolean hiHaEtapes = false;
boolean blinkOff = false;
boolean iniciPerBotoIniciar = false;
boolean comprovarMovEixY = false;
boolean puntDeCanvi;
boolean tornarEixYa0 = false;
boolean countEtapaIniciat;
boolean segonRotatori = false;
boolean aplicarMenysVelPrimeraPasada = false;
boolean platAzero = false;

byte mode = 0;      // 0 = desplaçament, 1 = edicio
byte pantalla;      // pantalles dins dels diferents nivells
byte columna;
byte filera;
byte configNivell;
byte direccioCarroManual;
byte direccioCarroAuto; // 0=dreta, 1=esquerra
byte movimentsAutomatics;
byte passadesRestants;
byte completo = 0;
byte augment = 0;
byte movimentAutoActual;
byte runSpeedActivat = 0;
byte segonsCicle;
byte medicioActual = 0;
byte fase;
byte indexRespostaFA;
byte respostaRTC = 233;
byte grauDivisor = 0;
byte grauDivisorDecimal = 0;
byte grauDivisorAux = 0;
byte grauDivisorDecimalAux = 0;
byte nPunts = 0;
int8_t offsetDivisor;
byte offsetDivisorDecimal;
byte funcioRotatoriManual = 0;
byte fcDretAssolit = 0;
byte fcEsquerreAssolit = 0;
int8_t idxArrayEsmolat = -1;
byte nProgs;
byte sentitDivisor; // 0 == Anti-clockwise. 1 == Clockwise
int8_t dirEixYauto = 1;
byte colAux;
byte quartEix;
byte velAux;
byte cAux;
byte fAux;
byte angleAux;
byte angleDecAux;

// Variables de Programa
int8_t offsetV = 0;
int8_t offsetVdec = 0;
int8_t offsetDivDec = 0;
int valor = 0;
int valorLim = 0;
int valorDec = 0;
int valorDecLim = 0; // El limit LOW sempre
int divDec = 0;
int intEnEdicio;
int intEnEdicio_limitLow;
int intEnEdicio_limitHigh;
int desbastDec = 0;
int desbastDivDec = 0;
int acabatDec = 0;
int dentActual = 0;
int nDents = 0;
int intAux;
int pos;
int posAux;
int idxCurrentVel;

int valorEncoderOld;
int valorEncoderNew;
int total;
int divisor;
int nBaixades;
int ultimaBaixadaResteValor;
int aux;
int count = 0;     // comptador de les baixades o moviments de carro (segons si no lapeado o lapeado) del total a realitzar en moviment automatic
int nCuchilla = 1;
long stepsEixXmanual;
long stepsEixXautomatic;
long stepsEixXautomaticAux;
long stepsEixYautomatic;
int stepsAccInterrompuda = 0;
int minutsCicle;
int valorNominal;
int valorMedicio;
int valorLimit;
int ultimValorDesbaste;
int ultimValorAcabado;
int idxVar;
int idxVarAux;
int increment = 1;
int velMola;

float ramp_time;
float analogRpm;

long carregaEixZtotal = 0;
long carregaEixZetapa = 0;
long eixZcurrentPosition = 0L;
long molaPosicioAngle1 = 0L;
long molaPosicioAngle2 = 0L;
long eixYcurrentPosition = 0L;
long eixAcurrentPosition = 0;
long eixAposActual = 0L;
long eixZposActual = 0L;
long eixYposActual = 0L;
long distanciaAlsada;
long initPosYauto;
long pasDentAcumulat = 0L;
long longEnEdicio = 0UL;
long longEnEdicio_limitHigh;
long recorregutZ;
long recorregutY;

unsigned long tempsCicle = 0UL;
unsigned long tempsConfirmarAutoOsalir = 0UL;
unsigned long tempsCarroDeFCx1AFCx2 = 0UL;
unsigned long gestioTemps = 0UL;
unsigned long gestioTemps2 = 0UL;

/*
    vars MAP:
      0:    angleHelix         min -90   max 90    max_digits 2    enter/decimal 0(enter) 1(decimal)
      3:    angleHelixDec      min 0     max 9     ...
      6:    recAfilat
      9:    recAfilatDec:
      12:   desbast
      15:   desbastDecLow
      18:   desbastDecHigh
      21:   desbastDivDecLow
      24:   desbastDivDecHigh
      27:   desbastVel
      30:   lapejat
      33:   lapejatVel
      36:   girHelix
      39:   modeFunc
      42:   
      
    ESTRUCTURA:
      valorVariable, minim, maxim, digitsMaxims, enter/decimal (cas variable numerica), pos varsString (cas variable text)
      
    VALORS DE 16 BITS O MES (> a 255):
      representants amb dos variables low i high
      Les propietats digitsMaxims i enter/decimal fan referencia a la variable unica que representen
      Per tant son dos propietats identiques en les dues variables
 */

byte vars[N_INDEX_VARS*PROPS_VAR] = {0, DESBAST_L, DESBAST_H, 2, 0, 0, DESBAST_DEC_LOW_L, DESBAST_DEC_LOW_H, 3, 1, 0, DESBAST_DEC_HIGH_L, DESBAST_DEC_HIGH_H, 3, 1, 1, DESBASTDIV_DEC_LOW_L, DESBASTDIV_DEC_LOW_H, 3, 1, 0, DESBASTDIV_DEC_HIGH_L, DESBASTDIV_DEC_HIGH_H, 3, 1, 1, DESBAST_VEL_L, DESBAST_VEL_H, 3, 0, 0, ACABAT_L, ACABAT_H, 0, 0, 0, ACABAT_DEC_LOW_L, ACABAT_DEC_LOW_H, 3, 1, 0, ACABAT_DEC_HIGH_L, ACABAT_DEC_HIGH_H, 3, 1, 1, ACABATDIV_DEC_L, ACABATDIV_DEC_H, 3, 1, 1, ACABAT_VEL_L, ACABAT_VEL_H, 3, 0, 0, LAPEJAT_L, LAPEJAT_H, 2, 0, 1, LAPEJAT_VEL_L, LAPEJAT_VEL_H, 3, 0, 0, PRODUCCIO_L, PRODUCCIO_H, 1, idxProduccioPrint, 0, ANGLE1_L, ANGLE1_H, 2, 0, 0, ANGLE1_DEC_L, ANGLE1_DEC_H, 1, 0, 0, ANGLE2_L, ANGLE2_H, 2, 0, 0, ANGLE2_DEC_L, ANGLE2_DEC_H, 1, 0, 0, GIRMOLA_L, GIRMOLA_H, 1, idxGirMolaPrint, 0, BAIXADA_L, BAIXADA_H, 1, idxBaixadaPrint, 0, MEDICIO_L, MEDICIO_H, 1, idxMedicioPrint, 1, NDENTS_LOW_L, NDENTS_LOW_H, 4, 0, 1, NDENTS_HIGH_L, NDENTS_HIGH_H, 4, 0, 0, PASDENT_L, PASDENT_H, 2, 0, 0, PASDENT_DEC_L, PASDENT_DEC_H, 1, 1, 0, ANGLE3_L, ANGLE3_H, 2, 0, 0, ANGLE3_DEC_L, ANGLE3_DEC_H, 1, 1, 0, MOLARPM_LOW_L, MOLARPM_LOW_H, 5, 0, 0, MOLARPM_HIGH_L, MOLARPM_HIGH_H, 5, 0, 0, RECAFILAT_L, RECAFILAT_H, 3, 0, 0, ACTIVAR_MEDICIO_L, ACTIVAR_MEDICIO_H, 1, idxActivarMedicioPrint, 0, INCREMENT_VEL_LOW_L, INCREMENT_VEL_LOW_H, 3, 0, 0, INCREMENT_VEL_HIGH_L, INCREMENT_VEL_HIGH_H, 3, 0, 100, ACC_LOW_L, ACC_LOW_H, 4, 0, 0, ACC_HIGH_L, ACC_HIGH_H, 4, 0, 50, DACC_LOW_L, DACC_LOW_H, 4, 0, 0, DACC_HIGH_L, DACC_HIGH_H, 4, 0, 0, ACTIVAR_MAGNETISME_L, ACTIVAR_MAGNETISME_H, 1, idxActivarMagnetismePrint, 100, RECORREGUTZ_LOW_L, RECORREGUTZ_LOW_H, 6, 0, 0, RECORREGUTZ_HIGH_L, RECORREGUTZ_HIGH_H, 6, 0, 0, RECORREGUTZ_HIGH2_L, RECORREGUTZ_HIGH2_H, 6, 0, 0, QUART_EIX_L, QUART_EIX_H, 1, idxActivarQuartEixPrint, 100, RECORREGUTY_LOW_L, RECORREGUTY_LOW_H, 6, 0, 0, RECORREGUTY_HIGH_L, RECORREGUTY_HIGH_H, 6, 0, 0, RECORREGUTY_HIGH2_L, RECORREGUTY_HIGH2_H, 6, 0, 100, VELOCITATZ_LOW_L, VELOCITATZ_LOW_H, 4, 0, 0, VELOCITATZ_HIGH_L, VELOCITATZ_HIGH_H, 4, 0, 1, VELMANUALX_L, VELMANUALX_H, 3, 0, 1, STEPSMANUALZ_L, STEPSMANUALZ_H, 3, 1, 1, STEPSMANUALY_L, STEPSMANUALY_H, 3, 1, 0, OFFSETA_L, OFFSETA_H, 2, 0, 0, OFFSETA_DEC_L, OFFSETA_DEC_H, 1, 1, 10, SENSIBILITAT_LOW_L, SENSIBILITAT_LOW_H, 3, 0, 0, SENSIBILITAT_HIGH_L, SENSIBILITAT_HIGH_H, 3, 0, 0, COMPENSACIO_LOW_L, COMPENSACIO_LOW_H, 3, 1, 0, COMPENSACIO_HIGH_L, COMPENSACIO_HIGH_H, 3, 1, 0, REFRIGERACIO_L, REFRIGERACIO_H, 1, idxRefrigeracioPrint, 0, HORESTOTALS_LOW_L, HORESTOTALS_LOW_H, 5, 0, 0, HORESTOTALS_HIGH_L, HORESTOTALS_HIGH_H, 5, 0, 0, HORESCICLE_LOW_L, HORESCICLE_LOW_H, 4, 0, 0, HORESCICLE_HIGH_L, HORESCICLE_HIGH_H, 4, 0, 0, HORESRECANVIS_LOW_L, HORESRECANVIS_LOW_H, 4, 0, 0, HORESRECANVIS_HIGH_L, HORESRECANVIS_HIGH_H, 4, 0, 0, MINUTSCICLE_RESTANTS_L, MINUTSCICLE_RESTANTS_H, 2, 0, 0, CODIFINAL_INTRO_L, CODIFINAL_INTRO_H, 1, 0, 0, CODIPROV1_INTRO_L, CODIPROV1_INTRO_H, 1, 0, 0, CODIPROV2_INTRO_L, CODIPROV2_INTRO_H, 1, 0, 0, BYTE_ESTANDARD_L, BYTE_ESTANDARD_H, 3, 0, 0, BYTE_ESTANDARD_L, BYTE_ESTANDARD_H, 3, 0, 0, BYTE_ESTANDARD_L, BYTE_ESTANDARD_H, 3, 0, 0, BYTE_ESTANDARD_L, BYTE_ESTANDARD_H, 3, 0, 0, BYTE_ESTANDARD_L, BYTE_ESTANDARD_H, 3, 0, 0, BYTE_ESTANDARD_L, BYTE_ESTANDARD_H, 3, 0, 0, MAGNETITZAT_L, MAGNETITZAT_H, 1, 0, 0, PROGRAMA_L, PROGRAMA_H, 2, 0, 0, DIGIT_CODI_ACTUAL_L, DIGIT_CODI_ACTUAL_H, 1, 0};

char* varsString[10] = {" ", "Contrafilo     ", "A favor de filo", "NO", "SI", "Izquierda", "Derecha  ", "Ambos    ", "ON ", "OFF"};

byte valorsRtc[6];
byte valorsEep[6];
byte respostaFA[3] = {233, 233, 233};
byte myBytes[4];
byte digitsCodiActual[9] = {0,0,0,0,0,0,0,0,0};
byte xip1DigitalInputs[16] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
int xip2AnalogInputs[16] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
byte arrayEsmolat[5] = {0,0,0,0,0}; // ange1 desbaste, angle1 acabado, angle1 lapeado, angle2 acabado, angle2 lapeado
