
#include "MUX16In.h"
// Per a arduinos anteriors a versio 1.0, cambiar Arduino.h per <WProgram.h>
#if(ARDUINO >= 100)
#include <Arduino.h>
#else
#include <WProgram.h>
#endif
#include <stdlib.h>
#include <inttypes.h>

// Constructor
MUX16In::MUX16In(){
}
// Constructor 2
MUX16In::MUX16In(uint8_t Control0, uint8_t Control1, uint8_t Control2, uint8_t Control3, uint8_t digitalData, int analogData){
	setParameters(Control0, Control1, Control2, Control3, digitalData, analogData);
}

void MUX16In::setParameters(uint8_t Control0, uint8_t Control1, uint8_t Control2, uint8_t Control3, uint8_t digitalData, int analogData){
	c0 = Control0;
	c1 = Control1;
	c2 = Control2;
	c3 = Control3;
	pinMode(c0, OUTPUT);
	pinMode(c1, OUTPUT),
	pinMode(c2, OUTPUT);
	pinMode(c3, OUTPUT);

	dD = digitalData;
	aD = analogData;

	digitalWrite(dD, HIGH);
	//digitalWrite(aD, HIGH);
}

uint8_t MUX16In::readD(uint8_t pin){
	//The following 4 commands set the correct logic for the control pins to select the desired input
    //See the Arduino Bitwise AND Reference: http://www.arduino.cc/en/Reference/BitwiseAnd
    //See the Aruino Bitshift Reference: http://www.arduino.cc/en/Reference/Bitshift
	actualitzarPinsControl(pin);
	
	return !digitalRead(dD);
}

uint8_t MUX16In::readA(uint8_t pin){
	//The following 4 commands set the correct logic for the control pins to select the desired input
    //See the Arduino Bitwise AND Reference: http://www.arduino.cc/en/Reference/BitwiseAnd
    //See the Aruino Bitshift Reference: http://www.arduino.cc/en/Reference/Bitshift
	actualitzarPinsControl(pin);
	
	return analogRead(aD);
}

void MUX16In::actualitzarPinsControl(uint8_t pin){
	if((pin&15)>>3 == HIGH){
		PORTC|=(1<<PORTC5); // pin c0 valor ALT
	}
	else{
		PORTC&=~(1<<PORTC5); // pin c0 valor BAIX
	}
	if((pin&7)>>2 == HIGH){
		PORTC|=(1<<PORTC4); // pin c1 valor ALT
	}
	else{
		PORTC&=~(1<<PORTC4); // pin c1 valor BAIX
	}
	if((pin&3)>>1 == HIGH){
		PORTC|=(1<<PORTC3); // pin c2 valor ALT
	}
	else{
		PORTC&=~(1<<PORTC3); // pin c2 valor BAIX
	}
	if((pin&1) == HIGH){
		PORTC|=(1<<PORTC2); // pin c3 valor ALT
	}
	else{
		PORTC&=~(1<<PORTC2); // pin c3 valor BAIX
	}
	/*
	digitalWrite(c0, (pin&15)>>3);
    digitalWrite(c1, (pin&7)>>2);
    digitalWrite(c2, (pin&3)>>1);
    digitalWrite(c3, (pin&1));	
    */
}

// Desconstructor
MUX16In::~MUX16In(){
}

/*
void MUX16In::readDb(uint8_t *muxDigital){
	//This for loop is used to scroll through and store the 16 inputs on the FIRST multiplexer
  	for (uint8_t i=0; i<16; i++){

    		//The following 4 commands set the correct logic for the control pins to select the desired input
    		//See the Arduino Bitwise AND Reference: http://www.arduino.cc/en/Reference/BitwiseAnd
    		//See the Aruino Bitshift Reference: http://www.arduino.cc/en/Reference/Bitshift

    		digitalWrite(c0, (i&15)>>3);
    		digitalWrite(c1, (i&7)>>2);
    		digitalWrite(c2, (i&3)>>1);
    		digitalWrite(c3, (i&1));

    		//Read and store the input
    		//Since internal pullup is on, the pin goes low on changing, so the value needs to be flipped from 0 to 1 (!)
		// En aquí tenim l'opció de dir si el xip realitza lectures digitals o analògiques. Les digitals estàn amb lògica inversa.
    		muxDigital[i] = !digitalRead(dD);		
  	}
}

void MUX16In::readAb(int *muxAnalog){
	//This for loop is used to scroll through and store the 16 inputs on the FIRST multiplexer
  	for (uint8_t i=0; i<16; i++){

    		//The following 4 commands set the correct logic for the control pins to select the desired input
    		//See the Arduino Bitwise AND Reference: http://www.arduino.cc/en/Reference/BitwiseAnd
    		//See the Aruino Bitshift Reference: http://www.arduino.cc/en/Reference/Bitshift

    		digitalWrite(c0, (i&15)>>3);
    		digitalWrite(c1, (i&7)>>2);
    		digitalWrite(c2, (i&3)>>1);
    		digitalWrite(c3, (i&1));

    		//Read and store the input
    		//Since internal pullup is on, the pin goes low on changing, so the value needs to be flipped from 0 to 1 (!)
		// En aquí tenim l'opció de dir si el xip realitza lectures digitals o analògiques. Les digitals estàn amb lògica inversa.
    		muxAnalog[i] = analogRead(aD);
		
  	}
}

*/
