// Apte per a 2 registres externs de 8 pins cadascun


#include "OUT16.h"
// Per a arduinos anteriors a versio 1.0, cambiar Arduino.h per <WProgram.h>
#if(ARDUINO >= 100)
#include <Arduino.h>
#else
#include <WProgram.h>
#endif
#include <stdlib.h>
#include <inttypes.h>

// Constructor
OUT16::OUT16(){
}

// Constructor 2
OUT16::OUT16(uint8_t LatchPin, uint8_t ClockPin, uint8_t DataPin){
	setParameters(LatchPin, ClockPin, DataPin);
}

void OUT16::setParameters(uint8_t LatchPin, uint8_t ClockPin, uint8_t DataPin){
	latchPin = LatchPin;
	clockPin = ClockPin;
	dataPin = DataPin;

	pinMode(latchPin, OUTPUT);
	pinMode(clockPin, OUTPUT);
	pinMode(dataPin, OUTPUT);

	dataOut1 = 0;
	dataOut2 = 0;
	valorSortida = 0;

	uint8_t pinsTotals = 2*8;
	pinValues = (uint8_t*)malloc(pinsTotals*sizeof(uint8_t));
	//arrayOuts = (uint8_t*)malloc(8*sizeof(uint8_t));
		
	for(uint8_t i = 0; i < pinsTotals; i++){
		pinValues[i] = 0;
		//if(i < 8){
			//arrayOuts[i] = 0;
		//}
	}
}

void OUT16::write(uint8_t pin, uint8_t value){

	// Invertim valors perquè sinó amb la placa HMI1284, quan indiquem LOW escriu HIGH, i viceversa
	if(value == 1){
		value = 1;
	}
	else if(value == 0){
		value = 0;
	}
	pinValues[pin] = value;
	uint8_t inici;

	if(pin < 8){		
		inici = 0;
	}
	else{
		inici = 8;
	}
  	uint8_t final = inici + 8;
  
  	uint8_t *xipActual = (uint8_t*)malloc(8*sizeof(uint8_t));
  	uint8_t j = 0;
  
  	// Obtenim l'array temporal amb els pins del xip actual
  	for(uint8_t i = inici; i < final; i++){
    		xipActual[j] = pinValues[i];
    		j++;
  	}
	
	calculBinariToDecimal(pin, xipActual);
	free(xipActual);
}

// No funciona, no utilitzar
/*void OUT16::write2(uint8_t pin, uint8_t valor){
	uint8_t valorSortida1;
	uint8_t valorSortida2;

	if(valor == 0){
		valorSortida &= ~(1 << pin);
	}
	else{
		valorSortida |= (1 <<pin);
	}
	valorSortida2 = (uint8_t)(valorSortida & 0x00FF);       // Dels 16 valors, agafem els 8 primers (més petits) per als valors del xip 1
	valorSortida1 = (uint8_t)((valorSortida & 0xFF00)>>8);  // Ídem per als valors del xip 2, però els més significatius.
								// com que Sortida2 és d'1 byte, i agafem els corresponents al byte 2 de Sortida, 									// desplaçem 8 bits a la dreta per a que ens agafi bé

	registerWrite(valorSortida2, valorSortida1);
}*/

void OUT16::calculBinariToDecimal(uint8_t pin, uint8_t *xipActual){
	// Passem l'array de bits (nombre binari) a decimal, per passar a ShiftOut
	uint8_t decimal = 0;
	for(uint8_t k = 0; k < 8; k++){
    		if(xipActual[k] == 1){  // bit del byte activat
      			if(k == 0){
        			decimal = 1;   // si es el 1er, posem directament a 1 (2 elevat a 0 = 1)
      			}
      			else{
        			uint8_t res = 1;
        			for(uint8_t l = 1; l <= k; l++){
          				res = res * 2;
        			}
        			decimal = decimal + res;
      			}
    		}
  	}
	if(pin < 8){
		dataOut1 = decimal;
	}
	else{
		dataOut2 = decimal;
	}
	registerWrite(dataOut2, dataOut1);	// el primer valor modifica el xip 2. El 2on, el xip 1
}

void OUT16::registerWrite(uint8_t dataOut2, uint8_t dataOut1){
  	/*
     	  El canvi del latchPin de Low a High (el pin bloquejador), fa que les instruccions guardades a la memoria del
   	  chip, previament enviades per l'arduino, s'executin, fent que els leds mostrin llums
   	  Es com si el canvi d'estat del latchPin executes un print de les dades enviades per l'arduino
   	*/
 	digitalWrite(latchPin, LOW); // Els pins es bloquegen, impedint que es modifiqui el seu estat de llum. Sortida de dades bloquejada

  	shiftOut2(dataOut2);	// per a la primera entrada, shiftOut modifica el xip 2
	shiftOut2(dataOut1);	// per a la segona entrada, shiftOut modifica el xip 1

  	/*
     	  un cop finalitzat el tractat de dades, latchPin a HIGH obre la sortida de dades. El xip pot executar les instruccions
   	  guardades a la seva memoria i previament enviades per l'arduino amb les funcions anteriors
   	*/
  	digitalWrite(latchPin, HIGH); // Els pins ja poden mostrar la nova combinacio de bits marcara pel ShiftOut
}

void OUT16::shiftOut2(uint8_t myDataOut){
  	// This shifts 8 bits out MSB first, 
  	//on the rising edge of the clock,
  	//clock idles low

  	//internal function setup
  	//uint8_t i = 0;
  	uint8_t pinState;
  

  	//clear everything out just in case to
  	//prepare shift register for bit shifting
  	digitalWrite(dataPin, 0);
  	digitalWrite(clockPin, 0);

  	//for each bit in the byte myDataOut…
  	//NOTICE THAT WE ARE COUNTING DOWN in our for loop
  	//This means that %00000001 or "1" will go through such
  	//that it will be pin Q0 that lights.

  	for(int i = 7; i >= 0; i--){
    		digitalWrite(clockPin, 0);

	    	// if the value passed to myDataOut and a bitmask result 
	    	// true then... so if we are at i=6 and our value is
	   	// %11010100 it would the code compares it to %01000000 
	    	// and proceeds to set pinState to 1.
	    	if(myDataOut & (1<<i)){
	      		pinState= 1;
	    	}
	    	else{	
	      		pinState= 0;
	    	}
		//arrayOuts[i] = pinState;
	    	//Sets the pin to HIGH or LOW depending on pinState
	    	digitalWrite(dataPin, pinState);
	    	//register shifts bits on upstroke of clock pin  
	    	digitalWrite(clockPin, 1);
	    	//zero the data pin after shift to prevent bleed through
	    	digitalWrite(dataPin, 0);
  	}

  	//stop shifting
  	digitalWrite(clockPin, 0);
}

//uint8_t* getArrayOuts(){
	//return arrayOuts;
//}

// Desconstructor
OUT16::~OUT16(){
  	free(pinValues);
}
